﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
  [Item("ChangeNodeTypeMoveAbsoluteAttribute", "")]
  [StorableClass]
  public class ChangeNodeTypeMoveAbsoluteAttribute : SymbolicExpressionTreeMoveAttribute {
    [Storable]
    public int[] Path { get; private set; }

    [Storable]
    public double[] PreviousOutput { get; private set; }

    // for debugging
    [Storable]
    public double[] NewOutput { get; private set; }

    [StorableConstructor]
    protected ChangeNodeTypeMoveAbsoluteAttribute(bool deserializing) : base(deserializing) { }
    protected ChangeNodeTypeMoveAbsoluteAttribute(ChangeNodeTypeMoveAbsoluteAttribute original, Cloner cloner)
      : base(original, cloner) {
      this.Path = (int[])original.Path.Clone();
      this.PreviousOutput = original.PreviousOutput;
      this.NewOutput = original.NewOutput;
    }
    public ChangeNodeTypeMoveAbsoluteAttribute(int[] path, double moveQuality, double[] prevOutput, double[] newOutput)
      : base(moveQuality) {
      Path = path;
      PreviousOutput = prevOutput;
      NewOutput = newOutput;
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new ChangeNodeTypeMoveAbsoluteAttribute(this, cloner);
    }
  }
}
